﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.3
@EndOfDesignText@
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI
	Public world As B2World
	Public Ground As X2BodyWrapper
	Private ivForeground As B4XView
	Private ivBackground As B4XView
	Public lblStats As B4XView
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("1")
	world.Initialize("world", world.CreateVec2(0, -10))
	X2.Initialize(Me, ivForeground, world)
	'Configure the dimensions. Center point is (0, 3) and the visible width is 6 meters.
	X2.ConfigureDimensions(world.CreateVec2(0, 3), 6)
	'Load the graphics and add them to the cache.
	DrawStaticBackground
	Dim sb As X2ScaledBitmap = X2.LoadBmp(File.DirAssets, "Blue_Donut_7.png", 0.6, 0.6)
	'set antialiasing to true as this is a small image and the circle will look bad without it.
	X2.GraphicCache.PutGraphic2("donut", Array(sb), True, 5)
	CreateBoundaries
	'comment to disable debug drawing
	X2.EnableDebugDraw
End Sub

Public Sub DrawStaticBackground
	Dim sb As X2ScaledBitmap = X2.LoadBmp2(File.DirAssets, "background.png", X2.ScreenAABB.Width, X2.ScreenAABB.Height, 1)
	Dim bc As BitmapCreator
	bc.Initialize(ivBackground.Width / xui.Scale, ivBackground.Height / xui.Scale)
	bc.FillRadialGradient(Array As Int(0xFF994200, 0xFFDFDA66), bc.TargetRect)
	bc.DrawBitmap(sb.Bmp, bc.TargetRect, False)
	ivBackground.SetBitmap(bc.Bitmap)
End Sub
 
Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	
End Sub

Public Sub BeforeTimeStep (GS As X2GameStep)
	
End Sub

Public Sub Tick (GS As X2GameStep)
	If X2.RndFloat(0, 500) < X2.TimeStepMs Then '~1 per 0.5 second
		CreateDonut
	End If
End Sub

Private Sub CreateBoundaries
	Dim chain As B2ChainShape
	chain.Initialize
	'the values are based on background.png coordinates
	Dim ImagePoints() As Object = Array(Array(22, 188), _
		Array(22, 300), Array(22, 540), Array(314, 350), Array(778, 540) _
		, Array(776, 258))
	Dim OriginalBmpWidth As Int = 800
	Dim OriginalBmpHeight As Int = 600
	Dim vertics As List
	vertics.Initialize
	For Each xy() As Object In ImagePoints
		vertics.Add(X2.CreateVec2(X2.ScreenAABB.BottomLeft.X + xy(0) / OriginalBmpWidth * X2.ScreenAABB.Width, _
			X2.ScreenAABB.BottomLeft.Y + (OriginalBmpHeight - xy(1)) / OriginalBmpHeight * X2.ScreenAABB.Height))
	Next
	chain.CreateChain(vertics)
	Dim bd As B2BodyDef
	bd.BodyType = bd.TYPE_STATIC
	Dim bw As X2BodyWrapper = X2.CreateBodyAndWrapper(bd, Null, "boundaries")
	bw.Body.CreateFixture2(chain, 1)
End Sub

Private Sub CreateDonut
	Dim bd As B2BodyDef
	bd.BodyType = bd.TYPE_DYNAMIC
	bd.Position = X2.CreateVec2(X2.RndFloat(X2.ScreenAABB.BottomLeft.X, X2.ScreenAABB.TopRight.X), 5)
	Dim bw As X2BodyWrapper = X2.CreateBodyAndWrapper(bd, Null, "donut")
	bw.GraphicName = "donut"
	bw.DestroyIfInvisible = True
	Dim circle As B2CircleShape
	circle.Initialize(X2.GraphicCache.GetGraphicSizeMeters(bw.GraphicName, 0).X / 2)
	Dim f As B2Fixture = bw.Body.CreateFixture2(circle, 1)
	f.Restitution = 0.5
End Sub

